subroutine sub_eulerequationerror(euler_errors,value,g_k,g_c,grid_k,length_grid_k,y,transition)
		
	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_grid_k

	real(dp), dimension(length_grid_k,n_tauchen), intent(in) :: value, g_k, g_c
	real(dp), dimension(length_grid_k,n_tauchen), intent(out) :: euler_errors
	real(dp), dimension(n_tauchen,n_tauchen), intent(in) :: transition
	real(dp), dimension(length_grid_k), intent(in) :: grid_k
	real(dp), dimension(n_tauchen), intent(in) :: y
	
	integer :: index_k, index_z

	real(dp), dimension(length_grid_k,n_tauchen) :: c, ctomorrow,rhs
	
	do index_z = 1,n_tauchen
		call sub_myinterp1(grid_k, g_c(:,index_z), g_k(:,index_z), length_grid_k, ctomorrow(:,index_z))
	enddo
	
	do index_k = 1,length_grid_k
		do index_z = 1,n_tauchen
			rhs(index_k,index_z)=ctomorrow(index_k,index_z)**(-tau)*(alpha*exp(y(index_z))*g_k(index_k,index_z)**(alpha-1)+1-delta)		
		enddo
	enddo
	
			
	do index_k = 1,length_grid_k
		do index_z = 1,n_tauchen
			c(index_k,index_z)=(beta*dot_product(transition(index_z,:),rhs(index_k,:)))**(-1/tau)	
		enddo
	enddo

	euler_errors=1-(c/g_c)

	open(unit=14,	file='euler_errors.txt', status = 'replace')
	write (14, '(41f20.10)') (euler_errors(i1, :), i1 = 1,length_grid_k)
	close(14)


end subroutine sub_eulerequationerror