subroutine sub_refinement(index_kp,index_z,k,z,grid_k,length_grid_k,transition,value,kp,mylabor,value_max_so_far)
		
	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_grid_k, index_kp, index_z
	

	real (dp), dimension(length_grid_k,n_tauchen), intent(in) :: value
	real (dp), dimension(n_tauchen,n_tauchen), intent(in) :: transition
	real (dp), dimension(length_grid_k), intent(in) :: grid_k
	real (dp), intent(in) :: k, z 
	real (dp), intent(out) :: kp, mylabor, value_max_so_far

	integer :: length_index, index_kp_low, index_kp_high, index_kp_now, go_on

	real (dp), dimension(n_tauchen) :: myvalue
	real (dp) :: c, kp_low, kp_high, kp_guess, kp_guess_new, value_comp, mylabor_guess

	index_kp_now = max(index_kp-1,1)
	kp = grid_k(index_kp_now)

	call sub_newton(kp,k,z,mylabor)

	c = exp(z)*(k**alpha)*(mylabor**(1-alpha))+(1-delta)*k-kp
	value_max_so_far = (1-beta)*(((c**theta)*((1-mylabor)**(1-theta)))**(1-tau))/(1-tau)+&
											&beta*dot_product(transition(index_z,:),value(index_kp_now,:))

	index_kp_low  = max(1,index_kp-2)
	index_kp_high = min(length_grid_k,index_kp)
	length_index = index_kp_high-index_kp_low+1
	
	kp_low  = grid_k(index_kp_low)
	kp_high = grid_k(index_kp_high) 
	kp_guess = kp_low+0.6*(kp_high-kp_low)

	go_on = 1
	do while (go_on == 1)

		call sub_myinterp3(grid_k(index_kp_low:index_kp_high),value(index_kp_low:index_kp_high,:),length_index,kp_guess,myvalue)
		
		call sub_newton(kp_guess,k,z,mylabor_guess)

		c = exp(z)*(k**alpha)*(mylabor_guess**(1-alpha))+(1-delta)*k-kp_guess
	
		if (c<0.0) then
			c = 0.00000001
		endif

		value_comp = (1-beta)*(((c**theta)*((1-mylabor_guess)**(1-theta)))**(1-tau))/(1-tau)+&
									&beta*dot_product(transition(index_z,:),myvalue)
				
		if (value_comp>value_max_so_far) then
			if (kp_guess<kp) then
				kp_high = kp
			else
				kp_low = kp
			endif
			kp_guess_new = kp_low+0.6*(kp_high-kp_low)
			kp = kp_guess
			value_max_so_far = value_comp 
		else
			if (kp_guess<kp) then
				kp_low = kp_guess
			else
				kp_high = kp_guess
			endif
			kp_guess_new = kp_low+0.6*(kp_high-kp_low)
		endif

		if (abs(kp_high-kp_low)<0.000001) go_on = 0
		kp_guess = kp_guess_new
	
	enddo
	
	kp = kp_guess
	mylabor = mylabor_guess

end subroutine sub_refinement